# -*- coding: cp1250 -*-

"""
Module "heap.py" contains three functions. First function "cr_heap" creates a binary
heap from the list, second "ins_el" adds an element to the end of the list and lets it
pop through the heap and third function "ret_min" removes the element from the top of
the heap and replaces it the next smallest number.

Modul "heap.py" obsahuje ti funkce. Prvn funkce "cr_heap" vytvo binrn haldu
ze seznamu, druh "ins_el" pid prvek na konec seznamu a nech ho prozkkat haldou a
tet "ret_min" odstran prvek z vrcholu haldy a nahrad ho dalm nejmenm slem.
"""

def cr_heap (seznam, index=2):
    heap=[]
    for i in seznam:
        ins_el (heap, i, index)
    return heap


def ins_el (sez, x, index=2):
    sez.append (x)
    # Inserted number index. (Index vloenho sla.)
    j = len(sez)    
    while j > 1:
        # Index of the replaced element. (Index nahrazenho prvku.)
        p = j / 2
        # Compares the insert element and its parent and eventually replace.
        # (Porovn vloen prvek, jeho nadazen prvek a ppadn je vymn.)
        if isinstance(sez[p-1],int):
            if sez[j-1] < sez[p-1]: 
                d = sez[j-1]
                sez[j-1] = sez[p-1]
                sez[p-1] = d
                # Shift in the heap to the predecessor. (Posun v hald na pedchdce.)
                j = p   
            else:                       
                break
        else:
            if sez[j-1][index] < sez[p-1][index]: 
                d = sez[j-1]
                sez[j-1] = sez[p-1]
                sez[p-1] = d
                # Shift in the heap to the predecessor. (Posun v hald na pedchdce.)
                j = p  
            else:                       
                break


def ret_min (heap, index=2):
    # Moves the first element of heap to the end and removes it. (Pesune prvn prvek haldy na konec a odstranho.)
    heap[0] = heap[-1]
    del heap [-1]       
    # Index of the last number.(Index poslednho sla.)
    j = len(heap)-1   
    # Index of the comparison number.(Index porovnvanho sla.)
    i = 0               
    while j > 0: 
        # Index of the successor. (Index nslednka.)      
        n = 2*(i+1)-1   
        if n<len(heap):
            if isinstance(heap[n] and heap[i],int):
                # Checking whether there are both successors. (Kontrola zda existuj oba nslednci.)
                if n < j:
                    # Choose the smaller.(Vybere ten men.)
                    if heap [n+1] <  heap [n]:
                        n = n+1
                # If the number is greater than the successor, so exchanged. (Je-li slo vt ne nslednk, tak se vymn.)
                if heap[i] > heap[n]:
                    d = heap[n]
                    heap[n] = heap[i]
                    heap[i] = d
                    # Shift in the heap to the successor. (Posun v hald na nslednka.)
                    i = n   
                else:
                    break
            else:
                # Checking whether there are both successors. (Kontrola zda existuj oba nslednci.)
                if n < j:
                    # Choose the smaller.(Vybere ten men.)
                    if heap [n+1][index] < heap [n][index]:
                        n = n+1
                # If the number is greater than the successor, so exchanged. (Je-li slo vt ne nslednk, tak se vymn.)
                if heap[i][index] > heap[n][index]:
                    d = heap[n]
                    heap[n] = heap[i]
                    heap[i] = d                  
                    # Shift in the heap to the successor. (Posun v hald na nslednka.)
                    i = n   
                else:
                    break                      
        else:
            break
