# -*- coding: cp1250 -*-

"""
Module "rta.py" contains one function "raster_to_numpy" that loads the raster
and converts it into numpy.array. Next detects its coordinates, size of pixel,
number of columns and the number of lines.

Modul "rta.py" obsahuje jednu funkci "raster_to_numpy", kter nate rastr
a pevede ho do numpy.array. Dle zjist jeho souadnice, velikost pixelu,
poet sloupcu a poet dk.
"""

import arcpy, numpy

def raster_to_numpy(rastr):

    # Loads the raster.
    # Naten rastru.
    inRas = arcpy.Raster(rastr)   

    # Detects of grid coordinates.
    # Zjitn souadnic rastru.
    lowerLeftX = inRas.extent.XMin
    lowerLeftY = inRas.extent.YMin

    # Detects size of pixel.
    # Zjitn velikoti pixelu.
    sCell = inRas.meanCellWidth
    vCell = inRas.meanCellHeight

    # Converts raster into numpy.array.
    # Peveden rastru na numpy.array.
    new_ar = arcpy.RasterToNumPyArray(rastr, nodata_to_value= -999)

    # Detects number of columns.
    # Zjitn potu sloupc.
    Xmax = new_ar.shape[0]

    # Detects the number of lines.
    # Zjitn potu dku.
    Ymax = new_ar.shape[1]
    
    return new_ar, Xmax, Ymax, vCell, lowerLeftX, lowerLeftY
